unit OneWireTestMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  RackCtls;

type

  { TOneWireTestForm }

  TOneWireTestForm = class(TForm)
    LEDDisplay1: TLEDDisplay;
    QueryButton: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    procedure QueryButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public
    base_dir : string;
    serial_number : string;
    device_file : string;
  end;

var
  OneWireTestForm: TOneWireTestForm;

implementation

{$R *.lfm}

{ TOneWireTestForm }

procedure TOneWireTestForm.QueryButtonClick(Sender: TObject);
var
  lines : TStringList;
  line : string;
  txtf : textfile;
  value : real;
  i : integer;
begin

 lines := TStringList.create;
 {$IFDEF WIN32}
 base_dir :=  'c:/Temp/sys/bus/w1/devices/';
 {$ELSE}
 base_dir :=  '/sys/bus/w1/devices/';
 {$ENDIF}
 OpenDialog1.InitialDir := base_dir;
 if OpenDialog1.Execute then begin
   device_file := OpenDialog1.Filename;
 end
 else begin
   serial_number := '22-000000219f58';
   device_file := base_dir + serial_number + '/w1_slave';
 end;
 Edit1.text := device_file;
 lines.Delimiter := ' ';
 lines.StrictDelimiter := TRUE;
 AssignFile(txtf, device_file);
 try
   Reset(txtf);
   ReadLn(txtf, line);
   lines.DelimitedText := line;
   for i:= 0 to lines.Count-1 do
       Memo1.Lines.Add(lines.Strings[i]);
   if lines.Strings[lines.Count-1] = 'YES' then begin
     ReadLn(txtf, line);
     lines.DelimitedText := line;
     for i:= 0 to lines.Count-1 do
         Memo1.Lines.Add(lines.Strings[i]);
     line := lines.Strings[lines.Count-1];
     lines.Delimiter := '=';
     lines.DelimitedText := line;
     if (lines.count = 2) then begin
          Memo1.Lines.Add(lines.Strings[1]);
          i := strtoint(lines.Strings[1]);
          value := i/1000.0;
          line := floattostr(value);
          LedDisplay1.Value := value;
          Memo1.Lines.Add(line);
          Timer1.Enabled := TRUE;  // Now we have a valid path.
     end;
   end;
 except
   lines.DelimitedText := '';
 end;
 lines.Destroy;
 closefile(txtf);
end;

procedure TOneWireTestForm.Timer1Timer(Sender: TObject);
var
  lines : TStringList;
  line : string;
  txtf : textfile;
  value : real;
  i : integer;
begin
 lines := TStringList.create;
 lines.Delimiter := ' ';
 lines.StrictDelimiter := TRUE;
 AssignFile(txtf, device_file);
 try
   Reset(txtf);
   ReadLn(txtf, line);
   lines.DelimitedText := line;
   if lines.Strings[lines.Count-1] = 'YES' then begin
     ReadLn(txtf, line);
     lines.DelimitedText := line;
     line := lines.Strings[lines.Count-1];
     lines.Delimiter := '=';
     lines.DelimitedText := line;
     if (lines.count = 2) then begin
          Memo1.Lines.Add(lines.Strings[1]);
          i := strtoint(lines.Strings[1]);
          value := i/1000.0;
          line := floattostr(value);
          LedDisplay1.Value := value;
          Timer1.Enabled := TRUE;  // Now we have a valid path.
     end;
   end;
 except
   lines.DelimitedText := '';
 end;
 lines.Destroy;
 closefile(txtf);

end;

end.

